#!/usr/bin/env python
# -*- coding: utf-8 -*-
# License:: GPL
# Author:: Alberto Milone (aka tseliot) (mailto:albertomilone@alice.it)
# Website:: http://albertomilone.com

import os
import time
import tarfile
from subprocess import Popen, PIPE

def cmdoutput(command, verbose=None):
    '''
    USAGE: 
    * the command must be a string
    * you can pass 'noverbose' in order to make sure that stderr > /dev/null
    '''
    if verbose == 'noverbose':
        NULL = open('/dev/null', 'w')
        comnd = Popen(command, shell=True, stdout=PIPE, stderr=NULL)
        sts = os.waitpid(comnd.pid, 0)
        NULL.close()
    else:
        comnd = Popen(command, shell=True)# stdout=PIPE)
        sts = os.waitpid(comnd.pid, 0)

def getlocaltime():
    localt = time.localtime()
    timelist = []
    for i in localt:
        if len(str(i)) > 1:
            timelist.append(str(i))
        else:
            timelist.append('0' + str(i))
            
    timelist = timelist[0:6]
    dmy = timelist[0:3]
    dmy.reverse()
    localtime = '-'.join(dmy) + '-' + ':'.join(timelist[3:6])
    return localtime
    
def getusername():
    username = os.popen('id -un').readlines()[0][0:-1]
    return username

def getgroupname():
    groupname = os.popen('id -gn').readlines()[0][0:-1]
    return groupname

def checktar(myfile):
    '''
    Checks whether the file is a real tar file or not.
    returns a boolean value
    '''
    print 'CHECKING THE TAR FILE'
    tar = tarfile.open(myfile, "r:gz")
    for tarinfo in tar:
        real = True
        print tarinfo.name, "is", tarinfo.size, "bytes in size and is",
        break
        #if tarinfo.isreg():
            #print "a regular file."
        #elif tarinfo.isdir():
            #print "a directory."
        #else:
            #print "something else."
    tar.close()
    try:
        if real:
            print 'is real'
    except UnboundLocalError:
        real = False
    return real
    
def isinuse(app, arg):
    a = os.popen('ps ' + arg + ' | grep ' + app)
    b = a.readlines()
    if len(b) > 0:
        inuse = True
    else:
        inuse = False
    return inuse


    
    
    
